echo off
rem TS41.02
rem : %1 BMC_IP@ , %2 user , %3 password , %4 module number:

set /A ACcutoff=0
rem
echo ******************** IMPORTANT *************************
echo ********************************************************
echo ** DO NOT CUT OFF the main AC power of bullion server **
echo ** during the the EMM / ADM update                    **
echo ** the server MUST BE IN 'STANDBY' MODE (= POWER OFF) **
echo ********************************************************
echo .

echo ====================================================
echo ===========    Start update of MXB ADM     =========
echo ====================================================
echo .
ipmitool.exe -H %1 -U %2 -P %3 bulloem ver ADM1069_3_B_98 %4 > resu
grep 44.01.10 resu
 IF %ERRORLEVEL% NEQ 0 goto ADM-MXBuptodate
ipmitool.exe -H %1 -U %2 -P %3 bulloem upgrade ADM\ADM1069-MXB006-U4-I2C3B-0x98-V44_01_1_1.hex ADM1069_3_B_98 %4
ipmitool.exe -H %1 -U %2 -P %3 bulloem upgrade ADM\ADM1069-MXB006-U8-I2C3B-0x9A-V44_02_1_1.hex ADM1069_3_B_9A %4
ipmitool.exe -H %1 -U %2 -P %3 bulloem upgrade ADM\ADM1069-MXB006-U12-I2C3B-0x9C-V44_03_1_1.hex ADM1069_3_B_9C %4
ipmitool.exe -H %1 -U %2 -P %3 bulloem upgrade ADM\ADM1069-MXB006-U19-I2C3B-0x9E-V44_04_1_1.hex ADM1069_3_B_9E %4
ipmitool.exe -H %1 -U %2 -P %3 bulloem upgrade ADM\ADM1069-MXB006-U14-I2C3A-0x98-V44_05_1_1.hex ADM1069_3_A_98 %4
ipmitool.exe -H %1 -U %2 -P %3 bulloem upgrade ADM\ADM1069-MXB006-U15-I2C3A-0x9A-V44_06_1_1.hex ADM1069_3_A_9A %4
ipmitool.exe -H %1 -U %2 -P %3 bulloem upgrade ADM\ADM1069-MXB006-U16-I2C3A-0x9C-V44_07_1_1.hex ADM1069_3_A_9C %4
ipmitool.exe -H %1 -U %2 -P %3 bulloem upgrade ADM\ADM1069-MXB006-U17-I2C3A-0x9E-V44_08_1_1.hex ADM1069_3_A_9E %4
set /A ACcutoff=1

:ADM-MXBuptodate

echo ====================================================
echo ===========    Start update of ILB ADM    ==========
echo ====================================================
echo .
ipmitool.exe -H %1 -U %2 -P %3 bulloem ver ADM1069_4_A_98 %4 > resu
grep 12.01.10 resu
 IF %ERRORLEVEL% NEQ 0 goto ADM-ILBuptodate
ipmitool.exe -H %1 -U %2 -P %3 bulloem upgrade ADM\ADM1069-ILB003-U6_E1-I2C4A-0x98-V12_01_1_1.hex ADM1069_4_A_98 %4
ipmitool.exe -H %1 -U %2 -P %3 bulloem upgrade ADM\ADM1069-ILB003-U7_E1-I2C4A-0x9A-V12_02_1_1.hex ADM1069_4_A_9A %4
ipmitool.exe -H %1 -U %2 -P %3 bulloem upgrade ADM\ADM1069-ILB003-U8_E1-I2C4A-0x9C-V12_03_1_1.hex ADM1069_4_A_9C %4
ipmitool.exe -H %1 -U %2 -P %3 bulloem upgrade ADM\ADM1069-ILB003-U5_E1-I2C4A-0x9E-V12_04_1_1.hex ADM1069_4_A_9E %4
set /A ACcutoff=1

:ADM-ILBuptodate
rem test if SIB exist
ipmitool.exe -H %1 -U %2 -P %3 bulloem listhw %4 > resu
grep ADM1062_4_A_28 resu
IF %ERRORLEVEL% NEQ 0 goto noSIB
rem OK SIB exist

echo ====================================================
echo ===========    Start update of SIB ADM    ==========
echo ====================================================
ipmitool.exe -H %1 -U %2 -P %3 bulloem ver ADM1062_4_A_28 %4 > resu
grep 20.01.10 resu
 IF %ERRORLEVEL% NEQ 0 goto ADM-SIBuptodate
ipmitool.exe -H %1 -U %2 -P %3 bulloem upgrade ADM\ADM1062-SIB001-U3-I2C4A-0x28-V20_01_1_1.hex ADM1062_4_A_28 %4
ipmitool.exe -H %1 -U %2 -P %3 bulloem upgrade ADM\ADM1062-SIB001-U13-I2C4A-0x2A-V20_02_1_1.hex ADM1062_4_A_2A %4
set /A ACcutoff=1

:ADM-SIBuptodate
:noSIB

:startPDBPIC
echo ====================================================
echo ==========   Start update of PDBPIC    =============
echo ====================================================
echo ************* The current version is : ************* 
ipmitool.exe -H %1 -U %2 -P %3 bulloem ver PDBPIC %4 > resu
grep 5 resu
 IF %ERRORLEVEL% NEQ 0 goto skipPDBPIC
type resu
echo on
ipmitool.exe -H %1 -U %2 -P %3 bulloem upgrade PDBPIC\raw_flash_pdbpic_firmware_06.hex PDBPIC %4
echo off
    IF %ERRORLEVEL% GTR 0 goto erreur
echo off
echo ====================================================
echo ===========    End update of PDBPIC     ============
goto startBMC

:skipPDBPIC
echo =======  No need to update PDBPIC firmware  ========


:startBMC
echo ====================================================
echo ============   Start update of BMC    ==============
echo ====================================================
echo ************* The current version is : ************* 
ipmitool.exe -H %1 -U %2 -P %3 bulloem ver BMC %4 > resu
rem !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
grep 11.20.15 resu
 IF %ERRORLEVEL% EQU 0 goto skipBMC
type resu
echo on
ipmitool.exe -H %1 -U %2 -P %3 bulloem upgrade EMM\fw-wub-wpcm450_bulldc_MESCA_112015_0021.bin BMC %4
echo off
    IF %ERRORLEVEL% GTR 0 goto erreur
echo ====================================================
echo =============    End update of BMC     =============
if %ACcutoff% == 1 goto needACcutoff
goto endBMC

:skipBMC
echo =========  No need to update BMC firmware  =========
if %ACcutoff% == 1 goto needACcutoff
goto END

:endBMC
echo ====================================================
echo .

ipmitool.exe -H %1 -U %2 -P %3 bmc reset cold
echo ************************************************
echo ************************************************	
echo ***    Automatic BMC reset started.          ***
echo ***    Please wait a few minutes             ***
echo *** to reconnect the System Hardware Console ***
echo ************************************************
echo ************************************************
goto END

:erreur
echo off
echo .	 
echo **************************************************************************************
echo * An error has occured, check the messages above                                     *
echo * The firmware upgrade is not fully completed                                        *
echo *                                                                                    *
echo * Usage : flashFW.bat  BMC_IP@  user  password  module_number                        *
echo * example : flashFW.bat 10.1.1.2 super pass 0                                        *
echo *                                                                                    *
echo **************************************************************************************
echo .
goto finalEND

:needACcutoff
echo .	 
echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
echo !!!   to take in account new firmware version   !!
echo !!!   do a main power cut OFF on module,        !!
echo !!!   by unplugging all AC power cables         !!
echo !!!   during 1 minute, or do a  Breaker OFF.    !!
echo !!!                 THEN                        !!
echo !!!   Continue the update procedure             !!
echo !!!   by executing STEP 2 "BIOS update".        !!
echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
goto finalEND

:END
echo .	 
echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
echo !!!   Continue the update procedure           !!
echo !!!   by executing STEP 2 "BIOS update".      !!
echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

:finalEND
